#!/usr/bin/php
<?php
set_include_path(get_include_path() . PATH_SEPARATOR . "/usr/local/mgr5/include/php");
define('__MODULE__', "pmruks");
require_once 'billmgr_util.php';

echo "Content-Type: text/html; charset=utf-8\n\n";
$client_ip = ClientIp();
$param = CgiInput();
//Debug("INPUT PARAMS: ".print_r($param, true));

if (empty($param['elid'])) throw new Exception("EMPTY ELID!");

$info = LocalQuery("payment.info", array("elid" => $param["elid"]));

$elid = (string)$info->payment->id;

$sum = $info->payment->paymethodamount;
$sum = $sum * 1;

$paymethod_params = (array)$info->payment->paymethod[1];

$merchant_id = $paymethod_params["merchant_id"];
$api_key = html_entity_decode($paymethod_params["api_key"]);

$project_params = (array)$info->payment->project;

$data = [
	'shop_id'	=> $merchant_id,
	'token'		=> $api_key,
	'order_id' 	=> $elid,
	'amount' 	=> $sum,
	'user_code' => $client_ip,
];

$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, "https://lk.rukassa.is/api/v1/create");
curl_setopt($curl, CURLOPT_POST, true);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded"));
curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data, '', '&'));
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
$resp = json_decode(curl_exec($curl), true);
curl_close($curl);

if (!empty($paymethod_params['paymentreceipt_type']) && $info->payment->items) {
    $params['gds'] = array();
    $payment_receipt_desc = $paymethod_params['payment_receipt_description'];
    foreach ($info->payment->items->item as $item) {
        $name = (string)$item->locale_name;
        if (stripos($name, 'Авансовый') !== false) {
            $name = $payment_receipt_desc;
        }
        $params['gds'][] = array(
            'name' => $name,
            'price' => (string)$item->amount,
            'quantity' => 1,
        );
    }
}

if(isset($resp['error'])){
    die($resp['message']);
}

echo '
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
</head>
<body>
<script>window.location.href = "'.$resp['url'].'";</script>
</body>
</html>';

?>