#!/usr/bin/php
<?php
set_include_path(get_include_path() . PATH_SEPARATOR . "/usr/local/mgr5/include/php");
define('__MODULE__', "pmruks");
require_once 'billmgr_util.php';

echo "Content-Type: text/html; charset=utf-8\n\n";

Debug('Вошли в файл ruksresult.php');
$params = CgiInput(true);

if (!function_exists('hash_equals')) {
	function hash_equals($str1, $str2) {
		if (strlen($str1) != strlen($str2)) return false;
		$res = $str1 ^ $str2;
		$ret = 0;
		for ($i = strlen($res) - 1; $i >= 0; $i--) {
			$ret |= ord($res[$i]);
		}
		return !$ret;
	}
}

if ($params) {

	$order_id = $params["order_id"];

	if (!$order_id) {
		Error('Empty order ID!');
		exit;
	}

	$info = LocalQuery("payment.info", array("elid" => $order_id));

	if ($info->payment->id) { //заказ сушествует в BM
		$sum = $info->payment[0]->paymethodamount;
		
		$paymethod_params = (array) $info->payment->paymethod[1];

		$api_key = $paymethod_params["api_key"];
		
		$sign = ServerAuth();
		$sign2 = hash_hmac('sha256', $params['id'] . '|' . $params['createdDateTime'] . '|' . $params['amount'], $api_key);
		
		if (hash_equals($sign2, $sign)) {
			LocalQuery("payment.setpaid", array("elid" => $order_id));
			Debug("payment.setpaid OK {$order_id}");
		} else {
			Error('Hash signature does not match');
		}

		
	} else {
		Error("Order not found in BM!");
	}
} else {
	Error("Empty params!");
}

?>